#
# Conditional build:
%bcond_without	asm		# disable assembler

Summary:	Zstandard - fast lossless compression algorithm
Summary(pl.UTF-8):	Zstandard - szybki, bezstratny algorytm kompresji
Name:		zstd
Version:	1.5.7
Release:	1%{?tld}
License:	BSD
Group:		Libraries
#Source0Download: https://github.com/facebook/zstd/releases
Source0:	https://github.com/facebook/zstd/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	619a019adbbc4536e7fb93cdbb01af3e
URL:		https://github.com/facebook/zstd
BuildRequires:	gcc >= 5:3.2
BuildRequires:	libstdc++-devel
BuildRequires:	lz4-devel
BuildRequires:	xz-devel
BuildRequires:	zlib-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%ifarch %{arm}
%define		archcflags	-DMEM_FORCE_MEMORY_ACCESS=1
%endif

%description
Zstd, short for Zstandard, is a fast lossless compression algorithm,
targeting real-time compression scenarios at zlib-level compression
ratio.

%description -l pl.UTF-8
Zstd (skrót od Zstandard) to szybki, bezstratny algorytm kompresji, do
zastosowwań przy kompresji w czasie rzeczywistym ze współczynnikiem
kompresji zbliżonym do biblioteki zlib.

%package devel
Summary:	Header files for Zstd library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki Zstd
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for Zstd library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki Zstd.

%package static
Summary:	Static Zstd library
Summary(pl.UTF-8):	Statyczna biblioteka Zstd
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static Zstd library.

%description static -l pl.UTF-8
Statyczna biblioteka Zstd.

%prep
%setup -q

%build
CC="%{__cc}" \
CXX="%{__cxx}" \
CFLAGS="%{rpmcflags} %{rpmcppflags} %{?archcflags}" \
CXXFLAGS="%{rpmcxxflags} %{rpmcppflags}" \
LDFLAGS="%{rpmldflags}" \
%{__make} allmost manual \
	V=1 \
	PREFIX=%{_prefix} \
	LIBDIR=%{_libdir} \
	%{!?with_asm:ZSTD_NO_ASM=1}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{_lib}

%{__make} install \
	V=1 \
	DESTDIR=$RPM_BUILD_ROOT \
	PREFIX=%{_prefix} \
	LIBDIR=%{_libdir}

%{__mv} $RPM_BUILD_ROOT%{_libdir}/libzstd.so.* $RPM_BUILD_ROOT/%{_lib}
ln -sf /%{_lib}/$(basename $RPM_BUILD_ROOT/%{_lib}/libzstd.so.*.*.*) $RPM_BUILD_ROOT%{_libdir}/libzstd.so

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc LICENSE CHANGELOG README.md
%attr(755,root,root) %{_bindir}/unzstd
%attr(755,root,root) %{_bindir}/zstd
%attr(755,root,root) %{_bindir}/zstdcat
%attr(755,root,root) %{_bindir}/zstdgrep
%attr(755,root,root) %{_bindir}/zstdless
%attr(755,root,root) %{_bindir}/zstdmt
%attr(755,root,root) /%{_lib}/libzstd.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/libzstd.so.1
%{_mandir}/man1/unzstd.1*
%{_mandir}/man1/zstd.1*
%{_mandir}/man1/zstdcat.1*
%{_mandir}/man1/zstdgrep.1*
%{_mandir}/man1/zstdless.1*

%files devel
%defattr(644,root,root,755)
%doc doc/{zstd_compression_format.md,zstd_manual.html,images}
%attr(755,root,root) %{_libdir}/libzstd.so
%{_includedir}/zdict.h
%{_includedir}/zstd.h
%{_includedir}/zstd_errors.h
%{_pkgconfigdir}/libzstd.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libzstd.a
%changelog
* Sun Feb 23 2025 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/zstd.git;a=log;h=master

* Wed Feb 19 2025 Jan Palus <atler@pld-linux.org> c5ff1ed
- up to 1.5.7

* Wed Mar 27 2024 Jan Palus <atler@pld-linux.org> 299bf6b
- up to 1.5.6

* Tue Apr 04 2023 Jan Palus <atler@pld-linux.org> eaeeab0
- up to 1.5.5

* Fri Feb 10 2023 Jan Palus <atler@pld-linux.org> 365d524
- BR: libstdc++-devel for gen_html

* Fri Feb 10 2023 Jan Palus <atler@pld-linux.org> bab6fee
- up to 1.5.4

* Thu Jul 28 2022 Jakub Bogusz <qboosh@pld-linux.org> f9d63dc
- fixed paths in .pc file; release 2

* Thu Jan 20 2022 Jan Palus <atler@pld-linux.org> 99c74a6
- up to 1.5.2

* Sat Jan 01 2022 Jakub Bogusz <qboosh@pld-linux.org> 74fb6f8
- explain asm issue also in place

* Wed Dec 29 2021 Jan Palus <atler@pld-linux.org> b46fcfe
- disable asm on non-x86_64 to fix exec stack; rel 2

* Tue Dec 21 2021 Jan Palus <atler@pld-linux.org> 62ae61c
- up to 1.5.1

* Fri May 14 2021 Jan Palus <atler@pld-linux.org> 8df4284
- up to 1.5.0

* Wed Mar 03 2021 Jan Palus <atler@pld-linux.org> c45ba9e
- up to 1.4.9

* Sat Jan 30 2021 Jan Palus <atler@pld-linux.org> 2ac4131
- disable parallel build

* Sat Jan 30 2021 Jan Palus <atler@pld-linux.org> f3c32c6
- on %{arm} prefer memory access compatibility over performance

* Sat Jan 30 2021 Jan Palus <atler@pld-linux.org> a69fd9d
- up to 1.4.8

* Wed Nov 25 2020 Jan Palus <atler@pld-linux.org> 67417d2
- always segfaults on i686, try rebuilding
- release 3 (by relup.sh)

* Sat Nov 14 2020 Jan Palus <atler@pld-linux.org> 4862656
- skip building contrib which ignores CFLAGS

* Sat Nov 14 2020 Jan Palus <atler@pld-linux.org> cfde35c
- pass CXX and CXXFLAGS

* Sat Oct 24 2020 Jan Rękorajski <baggins@pld-linux.org> f822df6
- enable parallel build
- rel 2

* Sat Oct 24 2020 Jan Rękorajski <baggins@pld-linux.org> 2a73dcc
- move shared library to / for rpm

